/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.337 Revision 1.407
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.337 2010/03/02 00:52:26 reavertm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.407 2012/10/11 16:50:53 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
21 22
22if has "${EAPI:-0}" 0 1 2; then 23if has "${EAPI:-0}" 0 1 2; then
23 24
24# @FUNCTION: epause 25# @FUNCTION: epause
25# @USAGE: [seconds] 26# @USAGE: [seconds]
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org" 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62} 63}
63 64
64fi 65fi
65 66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
66# @FUNCTION: ecvs_clean 80# @FUNCTION: ecvs_clean
67# @USAGE: [list of dirs] 81# @USAGE: [list of dirs]
68# @DESCRIPTION: 82# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains 83# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD. 84# internal CVS directories. Defaults to $PWD.
82esvn_clean() { 96esvn_clean() {
83 [[ -z $* ]] && set -- . 97 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85} 99}
86 100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
87# @FUNCTION: eshopts_push 149# @FUNCTION: eshopts_push
88# @USAGE: [options to `set` or `shopt`] 150# @USAGE: [options to `set` or `shopt`]
89# @DESCRIPTION: 151# @DESCRIPTION:
90# Often times code will want to enable a shell option to change code behavior. 152# Often times code will want to enable a shell option to change code behavior.
91# Since changing shell options can easily break other pieces of code (which 153# Since changing shell options can easily break other pieces of code (which
96# rather than `set` as there are some options only available via that. 158# rather than `set` as there are some options only available via that.
97# 159#
98# A common example is to disable shell globbing so that special meaning/care 160# A common example is to disable shell globbing so that special meaning/care
99# may be used with variables/arguments to custom functions. That would be: 161# may be used with variables/arguments to custom functions. That would be:
100# @CODE 162# @CODE
101# eshopts_push -o noglob 163# eshopts_push -s noglob
102# for x in ${foo} ; do 164# for x in ${foo} ; do
103# if ...some check... ; then 165# if ...some check... ; then
104# eshopts_pop 166# eshopts_pop
105# return 0 167# return 0
106# fi 168# fi
107# done 169# done
108# eshopts_pop 170# eshopts_pop
109# @CODE 171# @CODE
110eshopts_push() { 172eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then 173 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p) 174 estack_push eshopts "$(shopt -p)"
116 [[ $# -eq 0 ]] && return 0 175 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*" 176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
118 else 177 else
119 __ESHOPTS_SAVE__[$i]=$- 178 estack_push eshopts $-
120 [[ $# -eq 0 ]] && return 0 179 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*" 180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
122 fi 181 fi
123} 182}
124 183
125# @FUNCTION: eshopts_pop 184# @FUNCTION: eshopts_pop
126# @USAGE: 185# @USAGE:
127# @DESCRIPTION: 186# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding 187# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details. 188# eshopts_push call. See that function for more details.
130eshopts_pop() { 189eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments" 190 local s
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 )) 191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then 192 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}" 193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
138 else 194 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-" 195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}" 196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
141 fi 197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
142} 219}
143 220
144# @VARIABLE: EPATCH_SOURCE 221# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION: 222# @DESCRIPTION:
146# Default directory to search for patches. 223# Default directory to search for patches.
149# @DESCRIPTION: 226# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself). 227# Default extension for patches (do not prefix the period yourself).
151EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS 229# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION: 230# @DESCRIPTION:
154# Default options for patch: 231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
155# @CODE 240# @CODE
156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
157# --no-backup-if-mismatch - do not leave .orig files behind 242# --no-backup-if-mismatch - do not leave .orig files behind
158# -E - automatically remove empty files 243# -E - automatically remove empty files
159# @CODE 244# @CODE
160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE 246# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION: 247# @DESCRIPTION:
163# List of patches not to apply. Note this is only file names, 248# List of patches not to apply. Note this is only file names,
164# and not the full path. Globs accepted. 249# and not the full path. Globs accepted.
165EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
176# Only require patches to match EPATCH_SUFFIX rather than the extended 261# Only require patches to match EPATCH_SUFFIX rather than the extended
177# arch naming style. 262# arch naming style.
178EPATCH_FORCE="no" 263EPATCH_FORCE="no"
179 264
180# @FUNCTION: epatch 265# @FUNCTION: epatch
181# @USAGE: [patches] [dirs of patches] 266# @USAGE: [options] [patches] [dirs of patches]
182# @DESCRIPTION: 267# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can 268# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be 269# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify 270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things 271# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully. 272# apply successfully.
188# 273#
189# If you do not specify any options, then epatch will default to the directory 274# If you do not specify any patches/dirs, then epatch will default to the
190# specified by EPATCH_SOURCE. 275# directory specified by EPATCH_SOURCE.
276#
277# Any options specified that start with a dash will be passed down to patch
278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
191# 280#
192# When processing directories, epatch will apply all patches that match: 281# When processing directories, epatch will apply all patches that match:
193# @CODE 282# @CODE
194# ${EPATCH_FORCE} == "yes" 283# if ${EPATCH_FORCE} != "yes"
195# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else 285# else
197# *.${EPATCH_SUFFIX} 286# *.${EPATCH_SUFFIX}
198# @CODE 287# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering. 288# The leading ?? are typically numbers used to force consistent patch ordering.
213 echo "${1//?/=}" 302 echo "${1//?/=}"
214 } 303 }
215 304
216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
217 306
307 # First process options. We localize the EPATCH_OPTS setting
308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
218 # Let the rest of the code process one user arg at a time -- 319 # Let the rest of the code process one user arg at a time --
219 # each arg may expand into multiple patches, and each arg may 320 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values 321 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then 322 if [[ $# -gt 1 ]] ; then
222 local m 323 local m
238 local EPATCH_SUFFIX=$1 339 local EPATCH_SUFFIX=$1
239 340
240 elif [[ -d $1 ]] ; then 341 elif [[ -d $1 ]] ; then
241 # Some people like to make dirs of patches w/out suffixes (vim) 342 # Some people like to make dirs of patches w/out suffixes (vim)
242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"} 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
243 349
244 else 350 else
245 # sanity check ... if it isn't a dir or file, wtf man ? 351 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1 352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo 353 echo
251 eerror " ( ${EPATCH_SOURCE##*/} )" 357 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo 358 echo
253 die "Cannot find \$EPATCH_SOURCE!" 359 die "Cannot find \$EPATCH_SOURCE!"
254 fi 360 fi
255 361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
256 local PIPE_CMD 366 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in 367 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;; 368 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;; 369 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;; 370 bz2) PIPE_CMD="bzip2 -dc" ;;
278 # ???_arch_foo.patch 388 # ???_arch_foo.patch
279 # Else, skip this input altogether 389 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_ 390 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch 391 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \ 392 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \ 393 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \ 394 ${a} == all || \
285 ${a} == ${ARCH} ]] 395 ${a} == ${ARCH} ]]
286 then 396 then
287 continue 397 continue
288 fi 398 fi
289 399
290 # Let people filter things dynamically 400 # Let people filter things dynamically
318 local STDERR_TARGET="${T}/${patchname}.out" 428 local STDERR_TARGET="${T}/${patchname}.out"
319 if [[ -e ${STDERR_TARGET} ]] ; then 429 if [[ -e ${STDERR_TARGET} ]] ; then
320 STDERR_TARGET="${T}/${patchname}-$$.out" 430 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi 431 fi
322 432
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}" 433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
324 434
325 # Decompress the patch if need be 435 # Decompress the patch if need be
326 local count=0 436 local count=0
327 local PATCH_TARGET 437 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then 438 if [[ -n ${PIPE_CMD} ]] ; then
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }') 457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then 458 if [[ -n ${abs_paths} ]] ; then
349 count=1 459 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}" 460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi 461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
352 469
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/ 470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
354 while [[ ${count} -lt 5 ]] ; do 472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
355 # Generate some useful debug info ... 475 # Generate some useful debug info ...
356 ( 476 (
357 _epatch_draw_line "***** ${patchname} *****" 477 _epatch_draw_line "***** ${patchname} *****"
358 echo 478 echo
359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'" 479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
360 echo 480 echo
361 _epatch_draw_line "***** ${patchname} *****" 481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
362 ) >> "${STDERR_TARGET}" 487 ) >> "${STDERR_TARGET}"
363 488
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then 489 if [ $? -eq 0 ] ; then
365 ( 490 (
366 _epatch_draw_line "***** ${patchname} *****" 491 _epatch_draw_line "***** ${patchname} *****"
367 echo 492 echo
368 echo "ACTUALLY APPLYING ${patchname} ..." 493 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo 494 echo
370 _epatch_draw_line "***** ${patchname} *****" 495 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1 496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
372 ) >> "${STDERR_TARGET}" 501 ) >> "${STDERR_TARGET}"
373 502
374 if [ $? -ne 0 ] ; then 503 if [ $? -ne 0 ] ; then
375 echo 504 echo
376 eerror "A dry-run of patch command succeeded, but actually" 505 eerror "A dry-run of patch command succeeded, but actually"
399 eerror " ${STDERR_TARGET}" 528 eerror " ${STDERR_TARGET}"
400 echo 529 echo
401 die "Failed Patch: ${patchname}!" 530 die "Failed Patch: ${patchname}!"
402 fi 531 fi
403 532
404 # if everything worked, delete the patch log 533 # if everything worked, delete the full debug patch log
405 rm -f "${STDERR_TARGET}" 534 rm -f "${STDERR_TARGET}"
535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
406 eend 0 543 eend 0
407 done 544 done
408 545
409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching" 546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
410 : # everything worked 547 : # everything worked
411} 548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
412epatch_user() { 577epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options" 578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414 579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
415 # don't clobber any EPATCH vars that the parent might want 584 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check} 587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check} 588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check} 589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then 590 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \ 591 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \ 592 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \ 593 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch 595 epatch
427 break 596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
428 fi 598 fi
429 done 599 done
600 echo "none" > "${applied}"
601 return 1
430} 602}
431 603
432# @FUNCTION: emktemp 604# @FUNCTION: emktemp
433# @USAGE: [temp dir] 605# @USAGE: [temp dir]
434# @DESCRIPTION: 606# @DESCRIPTION:
462 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
463 fi 635 fi
464 fi 636 fi
465} 637}
466 638
467# @FUNCTION: egetent
468# @USAGE: <database> <key>
469# @MAINTAINER:
470# base-system@gentoo.org (Linux)
471# Joe Jezak <josejx@gmail.com> (OS X)
472# usata@gentoo.org (OS X)
473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
474# @DESCRIPTION:
475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
477# and pw (FreeBSD) used in enewuser()/enewgroup()
478egetent() {
479 case ${CHOST} in
480 *-darwin[678])
481 case "$2" in
482 *[!0-9]*) # Non numeric
483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
484 ;;
485 *) # Numeric
486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
502 ;;
503 esac
504 ;;
505 *-freebsd*|*-dragonfly*)
506 local opts action="user"
507 [[ $1 == "passwd" ]] || action="group"
508
509 # lookup by uid/gid
510 if [[ $2 == [[:digit:]]* ]] ; then
511 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
512 fi
513
514 pw show ${action} ${opts} "$2" -q
515 ;;
516 *-netbsd*|*-openbsd*)
517 grep "$2:\*:" /etc/$1
518 ;;
519 *)
520 type -p nscd >& /dev/null && nscd -i "$1"
521 getent "$1" "$2"
522 ;;
523 esac
524}
525
526# @FUNCTION: enewuser
527# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
528# @DESCRIPTION:
529# Same as enewgroup, you are not required to understand how to properly add
530# a user to the system. The only required parameter is the username.
531# Default uid is (pass -1 for this) next available, default shell is
532# /bin/false, default homedir is /dev/null, there are no default groups,
533# and default params sets the comment as 'added by portage for ${PN}'.
534enewuser() {
535 case ${EBUILD_PHASE} in
536 unpack|compile|test|install)
537 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
538 eerror "Package fails at QA and at life. Please file a bug."
539 die "Bad package! enewuser is only for use in pkg_* functions!"
540 esac
541
542 # get the username
543 local euser=$1; shift
544 if [[ -z ${euser} ]] ; then
545 eerror "No username specified !"
546 die "Cannot call enewuser without a username"
547 fi
548
549 # lets see if the username already exists
550 if [[ -n $(egetent passwd "${euser}") ]] ; then
551 return 0
552 fi
553 einfo "Adding user '${euser}' to your system ..."
554
555 # options to pass to useradd
556 local opts=
557
558 # handle uid
559 local euid=$1; shift
560 if [[ -n ${euid} && ${euid} != -1 ]] ; then
561 if [[ ${euid} -gt 0 ]] ; then
562 if [[ -n $(egetent passwd ${euid}) ]] ; then
563 euid="next"
564 fi
565 else
566 eerror "Userid given but is not greater than 0 !"
567 die "${euid} is not a valid UID"
568 fi
569 else
570 euid="next"
571 fi
572 if [[ ${euid} == "next" ]] ; then
573 for ((euid = 101; euid <= 999; euid++)); do
574 [[ -z $(egetent passwd ${euid}) ]] && break
575 done
576 fi
577 opts="${opts} -u ${euid}"
578 einfo " - Userid: ${euid}"
579
580 # handle shell
581 local eshell=$1; shift
582 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
583 if [[ ! -e ${ROOT}${eshell} ]] ; then
584 eerror "A shell was specified but it does not exist !"
585 die "${eshell} does not exist in ${ROOT}"
586 fi
587 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
588 eerror "Do not specify ${eshell} yourself, use -1"
589 die "Pass '-1' as the shell parameter"
590 fi
591 else
592 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
593 [[ -x ${ROOT}${shell} ]] && break
594 done
595
596 if [[ ${shell} == "/dev/null" ]] ; then
597 eerror "Unable to identify the shell to use, proceeding with userland default."
598 case ${USERLAND} in
599 GNU) shell="/bin/false" ;;
600 BSD) shell="/sbin/nologin" ;;
601 Darwin) shell="/usr/sbin/nologin" ;;
602 *) die "Unable to identify the default shell for userland ${USERLAND}"
603 esac
604 fi
605
606 eshell=${shell}
607 fi
608 einfo " - Shell: ${eshell}"
609 opts="${opts} -s ${eshell}"
610
611 # handle homedir
612 local ehome=$1; shift
613 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
614 ehome="/dev/null"
615 fi
616 einfo " - Home: ${ehome}"
617 opts="${opts} -d ${ehome}"
618
619 # handle groups
620 local egroups=$1; shift
621 if [[ ! -z ${egroups} ]] ; then
622 local oldifs=${IFS}
623 local defgroup="" exgroups=""
624
625 export IFS=","
626 for g in ${egroups} ; do
627 export IFS=${oldifs}
628 if [[ -z $(egetent group "${g}") ]] ; then
629 eerror "You must add group ${g} to the system first"
630 die "${g} is not a valid GID"
631 fi
632 if [[ -z ${defgroup} ]] ; then
633 defgroup=${g}
634 else
635 exgroups="${exgroups},${g}"
636 fi
637 export IFS=","
638 done
639 export IFS=${oldifs}
640
641 opts="${opts} -g ${defgroup}"
642 if [[ ! -z ${exgroups} ]] ; then
643 opts="${opts} -G ${exgroups:1}"
644 fi
645 else
646 egroups="(none)"
647 fi
648 einfo " - Groups: ${egroups}"
649
650 # handle extra and add the user
651 local oldsandbox=${SANDBOX_ON}
652 export SANDBOX_ON="0"
653 case ${CHOST} in
654 *-darwin*)
655 ### Make the user
656 if [[ -z $@ ]] ; then
657 dscl . create /users/${euser} uid ${euid}
658 dscl . create /users/${euser} shell ${eshell}
659 dscl . create /users/${euser} home ${ehome}
660 dscl . create /users/${euser} realname "added by portage for ${PN}"
661 ### Add the user to the groups specified
662 local oldifs=${IFS}
663 export IFS=","
664 for g in ${egroups} ; do
665 dscl . merge /groups/${g} users ${euser}
666 done
667 export IFS=${oldifs}
668 else
669 einfo "Extra options are not supported on Darwin yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: $@"
672 die "Required function missing"
673 fi
674 ;;
675 *-freebsd*|*-dragonfly*)
676 if [[ -z $@ ]] ; then
677 pw useradd ${euser} ${opts} \
678 -c "added by portage for ${PN}" \
679 die "enewuser failed"
680 else
681 einfo " - Extra: $@"
682 pw useradd ${euser} ${opts} \
683 "$@" || die "enewuser failed"
684 fi
685 ;;
686
687 *-netbsd*)
688 if [[ -z $@ ]] ; then
689 useradd ${opts} ${euser} || die "enewuser failed"
690 else
691 einfo " - Extra: $@"
692 useradd ${opts} ${euser} "$@" || die "enewuser failed"
693 fi
694 ;;
695
696 *-openbsd*)
697 if [[ -z $@ ]] ; then
698 useradd -u ${euid} -s ${eshell} \
699 -d ${ehome} -c "Added by portage for ${PN}" \
700 -g ${egroups} ${euser} || die "enewuser failed"
701 else
702 einfo " - Extra: $@"
703 useradd -u ${euid} -s ${eshell} \
704 -d ${ehome} -c "Added by portage for ${PN}" \
705 -g ${egroups} ${euser} "$@" || die "enewuser failed"
706 fi
707 ;;
708
709 *)
710 if [[ -z $@ ]] ; then
711 useradd ${opts} \
712 -c "added by portage for ${PN}" \
713 ${euser} \
714 || die "enewuser failed"
715 else
716 einfo " - Extra: $@"
717 useradd ${opts} "$@" \
718 ${euser} \
719 || die "enewuser failed"
720 fi
721 ;;
722 esac
723
724 if [[ ! -e ${ROOT}/${ehome} ]] ; then
725 einfo " - Creating ${ehome} in ${ROOT}"
726 mkdir -p "${ROOT}/${ehome}"
727 chown ${euser} "${ROOT}/${ehome}"
728 chmod 755 "${ROOT}/${ehome}"
729 fi
730
731 export SANDBOX_ON=${oldsandbox}
732}
733
734# @FUNCTION: enewgroup
735# @USAGE: <group> [gid]
736# @DESCRIPTION:
737# This function does not require you to understand how to properly add a
738# group to the system. Just give it a group name to add and enewgroup will
739# do the rest. You may specify the gid for the group or allow the group to
740# allocate the next available one.
741enewgroup() {
742 case ${EBUILD_PHASE} in
743 unpack|compile|test|install)
744 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
745 eerror "Package fails at QA and at life. Please file a bug."
746 die "Bad package! enewgroup is only for use in pkg_* functions!"
747 esac
748
749 # get the group
750 local egroup="$1"; shift
751 if [ -z "${egroup}" ]
752 then
753 eerror "No group specified !"
754 die "Cannot call enewgroup without a group"
755 fi
756
757 # see if group already exists
758 if [[ -n $(egetent group "${egroup}") ]]; then
759 return 0
760 fi
761 einfo "Adding group '${egroup}' to your system ..."
762
763 # options to pass to useradd
764 local opts=
765
766 # handle gid
767 local egid="$1"; shift
768 if [ ! -z "${egid}" ]
769 then
770 if [ "${egid}" -gt 0 ]
771 then
772 if [ -z "`egetent group ${egid}`" ]
773 then
774 if [[ "${CHOST}" == *-darwin* ]]; then
775 opts="${opts} ${egid}"
776 else
777 opts="${opts} -g ${egid}"
778 fi
779 else
780 egid="next available; requested gid taken"
781 fi
782 else
783 eerror "Groupid given but is not greater than 0 !"
784 die "${egid} is not a valid GID"
785 fi
786 else
787 egid="next available"
788 fi
789 einfo " - Groupid: ${egid}"
790
791 # handle extra
792 local eextra="$@"
793 opts="${opts} ${eextra}"
794
795 # add the group
796 local oldsandbox="${SANDBOX_ON}"
797 export SANDBOX_ON="0"
798 case ${CHOST} in
799 *-darwin*)
800 if [ ! -z "${eextra}" ];
801 then
802 einfo "Extra options are not supported on Darwin/OS X yet"
803 einfo "Please report the ebuild along with the info below"
804 einfo "eextra: ${eextra}"
805 die "Required function missing"
806 fi
807
808 # If we need the next available
809 case ${egid} in
810 *[!0-9]*) # Non numeric
811 for ((egid = 101; egid <= 999; egid++)); do
812 [[ -z $(egetent group ${egid}) ]] && break
813 done
814 esac
815 dscl . create /groups/${egroup} gid ${egid}
816 dscl . create /groups/${egroup} passwd '*'
817 ;;
818
819 *-freebsd*|*-dragonfly*)
820 case ${egid} in
821 *[!0-9]*) # Non numeric
822 for ((egid = 101; egid <= 999; egid++)); do
823 [[ -z $(egetent group ${egid}) ]] && break
824 done
825 esac
826 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
827 ;;
828
829 *-netbsd*)
830 case ${egid} in
831 *[!0-9]*) # Non numeric
832 for ((egid = 101; egid <= 999; egid++)); do
833 [[ -z $(egetent group ${egid}) ]] && break
834 done
835 esac
836 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
837 ;;
838
839 *)
840 groupadd ${opts} ${egroup} || die "enewgroup failed"
841 ;;
842 esac
843 export SANDBOX_ON="${oldsandbox}"
844}
845
846# @FUNCTION: edos2unix 639# @FUNCTION: edos2unix
847# @USAGE: <file> [more files ...] 640# @USAGE: <file> [more files ...]
848# @DESCRIPTION: 641# @DESCRIPTION:
849# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
850# to remove all of these text utilities from DEPEND variables because this 643# to remove all of these text utilities from DEPEND variables because this
851# is a script based solution. Just give it a list of files to convert and 644# is a script based solution. Just give it a list of files to convert and
852# they will all be changed from the DOS CRLF format to the UNIX LF format. 645# they will all be changed from the DOS CRLF format to the UNIX LF format.
853edos2unix() { 646edos2unix() {
854 echo "$@" | xargs sed -i 's/\r$//' 647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
855} 649}
856 650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
857# Make a desktop file ! 654# Make a .desktop file.
858# Great for making those icons in kde/gnome startmenu !
859# Amaze your friends ! Get the women ! Join today !
860# 655#
861# make_desktop_entry(<command>, [name], [icon], [type], [path]) 656# @CODE
862#
863# binary: what command does the app run with ? 657# binary: what command does the app run with ?
864# name: the name that will show up in the menu 658# name: the name that will show up in the menu
865# icon: give your little like a pretty little icon ... 659# icon: the icon to use in the menu entry
866# this can be relative (to /usr/share/pixmaps) or 660# this can be relative (to /usr/share/pixmaps) or
867# a full path to an icon 661# a full path to an icon
868# type: what kind of application is this ? for categories: 662# type: what kind of application is this?
663# for categories:
869# http://standards.freedesktop.org/menu-spec/latest/apa.html 664# http://standards.freedesktop.org/menu-spec/latest/apa.html
870# path: if your app needs to startup in a specific dir 665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
871make_desktop_entry() { 668make_desktop_entry() {
872 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
873 670
874 local exec=${1} 671 local exec=${1}
875 local name=${2:-${PN}} 672 local name=${2:-${PN}}
876 local icon=${3:-${PN}} 673 local icon=${3:-${PN}}
877 local type=${4} 674 local type=${4}
878 local path=${5} 675 local fields=${5}
879 676
880 if [[ -z ${type} ]] ; then 677 if [[ -z ${type} ]] ; then
881 local catmaj=${CATEGORY%%-*} 678 local catmaj=${CATEGORY%%-*}
882 local catmin=${CATEGORY##*-} 679 local catmin=${CATEGORY##*-}
883 case ${catmaj} in 680 case ${catmaj} in
884 app) 681 app)
885 case ${catmin} in 682 case ${catmin} in
886 accessibility) type=Accessibility;; 683 accessibility) type="Utility;Accessibility";;
887 admin) type=System;; 684 admin) type=System;;
888 antivirus) type=System;; 685 antivirus) type=System;;
889 arch) type=Archiving;; 686 arch) type="Utility;Archiving";;
890 backup) type=Archiving;; 687 backup) type="Utility;Archiving";;
891 cdr) type=DiscBurning;; 688 cdr) type="AudioVideo;DiscBurning";;
892 dicts) type=Dictionary;; 689 dicts) type="Office;Dictionary";;
893 doc) type=Documentation;; 690 doc) type=Documentation;;
894 editors) type=TextEditor;; 691 editors) type="Utility;TextEditor";;
895 emacs) type=TextEditor;; 692 emacs) type="Development;TextEditor";;
896 emulation) type=Emulator;; 693 emulation) type="System;Emulator";;
897 laptop) type=HardwareSettings;; 694 laptop) type="Settings;HardwareSettings";;
898 office) type=Office;; 695 office) type=Office;;
899 pda) type=PDA;; 696 pda) type="Office;PDA";;
900 vim) type=TextEditor;; 697 vim) type="Development;TextEditor";;
901 xemacs) type=TextEditor;; 698 xemacs) type="Development;TextEditor";;
902 *) type=;;
903 esac 699 esac
904 ;; 700 ;;
905 701
906 dev) 702 dev)
907 type="Development" 703 type="Development"
908 ;; 704 ;;
909 705
910 games) 706 games)
911 case ${catmin} in 707 case ${catmin} in
912 action|fps) type=ActionGame;; 708 action|fps) type=ActionGame;;
913 arcade) type=ArcadeGame;; 709 arcade) type=ArcadeGame;;
914 board) type=BoardGame;; 710 board) type=BoardGame;;
915 emulation) type=Emulator;; 711 emulation) type=Emulator;;
916 kids) type=KidsGame;; 712 kids) type=KidsGame;;
917 puzzle) type=LogicGame;; 713 puzzle) type=LogicGame;;
918 roguelike) type=RolePlaying;; 714 roguelike) type=RolePlaying;;
919 rpg) type=RolePlaying;; 715 rpg) type=RolePlaying;;
920 simulation) type=Simulation;; 716 simulation) type=Simulation;;
921 sports) type=SportsGame;; 717 sports) type=SportsGame;;
922 strategy) type=StrategyGame;; 718 strategy) type=StrategyGame;;
923 *) type=;;
924 esac 719 esac
925 type="Game;${type}" 720 type="Game;${type}"
926 ;; 721 ;;
927 722
928 gnome) 723 gnome)
937 type="Network;Email" 732 type="Network;Email"
938 ;; 733 ;;
939 734
940 media) 735 media)
941 case ${catmin} in 736 case ${catmin} in
737 gfx)
942 gfx) type=Graphics;; 738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
943 radio) type=Tuner;; 742 radio) type=Tuner;;
944 sound) type=Audio;; 743 sound) type=Audio;;
945 tv) type=TV;; 744 tv) type=TV;;
946 video) type=Video;; 745 video) type=Video;;
947 *) type=;; 746 esac
747 type="AudioVideo;${type}"
748 ;;
948 esac 749 esac
949 type="AudioVideo;${type}"
950 ;; 750 ;;
951 751
952 net) 752 net)
953 case ${catmin} in 753 case ${catmin} in
954 dialup) type=Dialup;; 754 dialup) type=Dialup;;
955 ftp) type=FileTransfer;; 755 ftp) type=FileTransfer;;
956 im) type=InstantMessaging;; 756 im) type=InstantMessaging;;
957 irc) type=IRCClient;; 757 irc) type=IRCClient;;
958 mail) type=Email;; 758 mail) type=Email;;
959 news) type=News;; 759 news) type=News;;
960 nntp) type=News;; 760 nntp) type=News;;
961 p2p) type=FileTransfer;; 761 p2p) type=FileTransfer;;
962 voip) type=Telephony;; 762 voip) type=Telephony;;
963 *) type=;;
964 esac 763 esac
965 type="Network;${type}" 764 type="Network;${type}"
966 ;; 765 ;;
967 766
968 sci) 767 sci)
969 case ${catmin} in 768 case ${catmin} in
970 astro*) type=Astronomy;; 769 astro*) type=Astronomy;;
971 bio*) type=Biology;; 770 bio*) type=Biology;;
972 calc*) type=Calculator;; 771 calc*) type=Calculator;;
973 chem*) type=Chemistry;; 772 chem*) type=Chemistry;;
974 elec*) type=Electronics;; 773 elec*) type=Electronics;;
975 geo*) type=Geology;; 774 geo*) type=Geology;;
976 math*) type=Math;; 775 math*) type=Math;;
977 physics) type=Physics;; 776 physics) type=Physics;;
978 visual*) type=DataVisualization;; 777 visual*) type=DataVisualization;;
979 *) type=;;
980 esac 778 esac
981 type="Education;Science;${type}" 779 type="Education;Science;${type}"
982 ;; 780 ;;
983 781
984 sys) 782 sys)
986 ;; 784 ;;
987 785
988 www) 786 www)
989 case ${catmin} in 787 case ${catmin} in
990 client) type=WebBrowser;; 788 client) type=WebBrowser;;
991 *) type=;;
992 esac 789 esac
993 type="Network;${type}" 790 type="Network;${type}"
994 ;; 791 ;;
995 792
996 *) 793 *)
1026 TryExec=${exec%% *} 823 TryExec=${exec%% *}
1027 Icon=${icon} 824 Icon=${icon}
1028 Categories=${type} 825 Categories=${type}
1029 EOF 826 EOF
1030 827
1031 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1032 834
1033 ( 835 (
1034 # wrap the env here so that the 'insinto' call 836 # wrap the env here so that the 'insinto' call
1035 # doesn't corrupt the env of the caller 837 # doesn't corrupt the env of the caller
1036 insinto /usr/share/applications 838 insinto /usr/share/applications
1037 doins "${desktop}" 839 doins "${desktop}"
1038 ) 840 ) || die "installing desktop file failed"
1039} 841}
1040 842
1041# @FUNCTION: validate_desktop_entries 843# @FUNCTION: validate_desktop_entries
1042# @USAGE: [directories] 844# @USAGE: [directories]
1043# @MAINTAINER: 845# @MAINTAINER:
1138 insinto /usr/share/applications 940 insinto /usr/share/applications
1139 newins "$@" 941 newins "$@"
1140 ) 942 )
1141} 943}
1142 944
1143# @FUNCTION: doicon 945# @FUNCTION: _iconins
1144# @USAGE: <list of icons> 946# @INTERNAL
1145# @DESCRIPTION: 947# @DESCRIPTION:
1146# Install the list of icons into the icon directory (/usr/share/pixmaps). 948# function for use in doicon and newicon
1147# This is useful in conjunction with creating desktop/menu files. 949_iconins() {
1148doicon() {
1149 ( 950 (
1150 # wrap the env here so that the 'insinto' call 951 # wrap the env here so that the 'insinto' call
1151 # doesn't corrupt the env of the caller 952 # doesn't corrupt the env of the caller
1152 local i j ret 953 local funcname=$1; shift
1153 insinto /usr/share/pixmaps 954 local size dir
1154 for i in "$@" ; do 955 local context=apps
1155 if [[ -f ${i} ]] ; then 956 local theme=hicolor
1156 doins "${i}" 957
1157 ((ret+=$?)) 958 while [[ $# -gt 0 ]] ; do
1158 elif [[ -d ${i} ]] ; then 959 case $1 in
1159 for j in "${i}"/*.png ; do 960 -s|--size)
1160 doins "${j}" 961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1161 ((ret+=$?)) 962 size=${2%%x*}
1162 done
1163 else 963 else
1164 ((++ret)) 964 size=${2}
1165 fi 965 fi
1166 done
1167 exit ${ret}
1168 )
1169}
1170
1171# @FUNCTION: newicon
1172# @USAGE: <icon> <newname>
1173# @DESCRIPTION:
1174# Like all other new* functions, install the specified icon as newname.
1175newicon() {
1176 (
1177 # wrap the env here so that the 'insinto' call
1178 # doesn't corrupt the env of the caller
1179 insinto /usr/share/pixmaps
1180 newins "$@"
1181 )
1182}
1183
1184# for internal use only (unpack_pdv and unpack_makeself)
1185find_unpackable_file() {
1186 local src=$1
1187 if [[ -z ${src} ]] ; then
1188 src=${DISTDIR}/${A}
1189 else
1190 if [[ -e ${DISTDIR}/${src} ]] ; then
1191 src=${DISTDIR}/${src}
1192 elif [[ -e ${PWD}/${src} ]] ; then
1193 src=${PWD}/${src}
1194 elif [[ -e ${src} ]] ; then
1195 src=${src}
1196 fi
1197 fi
1198 [[ ! -e ${src} ]] && return 1
1199 echo "${src}"
1200}
1201
1202# @FUNCTION: unpack_pdv
1203# @USAGE: <file to unpack> <size of off_t>
1204# @DESCRIPTION:
1205# Unpack those pesky pdv generated files ...
1206# They're self-unpacking programs with the binary package stuffed in
1207# the middle of the archive. Valve seems to use it a lot ... too bad
1208# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1209#
1210# You have to specify the off_t size ... I have no idea how to extract that
1211# information out of the binary executable myself. Basically you pass in
1212# the size of the off_t type (in bytes) on the machine that built the pdv
1213# archive.
1214#
1215# One way to determine this is by running the following commands:
1216#
1217# @CODE
1218# strings <pdv archive> | grep lseek
1219# strace -elseek <pdv archive>
1220# @CODE
1221#
1222# Basically look for the first lseek command (we do the strings/grep because
1223# sometimes the function call is _llseek or something) and steal the 2nd
1224# parameter. Here is an example:
1225#
1226# @CODE
1227# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1228# lseek
1229# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1230# lseek(3, -4, SEEK_END) = 2981250
1231# @CODE
1232#
1233# Thus we would pass in the value of '4' as the second parameter.
1234unpack_pdv() {
1235 local src=$(find_unpackable_file "$1")
1236 local sizeoff_t=$2
1237
1238 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1239 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1240
1241 local shrtsrc=$(basename "${src}")
1242 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1243 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1244 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1245
1246 # grab metadata for debug reasons
1247 local metafile=$(emktemp)
1248 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1249
1250 # rip out the final file name from the metadata
1251 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1252 datafile=$(basename "${datafile}")
1253
1254 # now lets uncompress/untar the file if need be
1255 local tmpfile=$(emktemp)
1256 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1257
1258 local iscompressed=$(file -b "${tmpfile}")
1259 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1260 iscompressed=1
1261 mv ${tmpfile}{,.Z}
1262 gunzip ${tmpfile}
1263 else
1264 iscompressed=0
1265 fi
1266 local istar=$(file -b "${tmpfile}")
1267 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1268 istar=1
1269 else
1270 istar=0
1271 fi
1272
1273 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1274 #dd if=${src} ibs=${metaskip} count=1 \
1275 # | dd ibs=${tailskip} skip=1 \
1276 # | gzip -dc \
1277 # > ${datafile}
1278 if [ ${iscompressed} -eq 1 ] ; then
1279 if [ ${istar} -eq 1 ] ; then
1280 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1281 | head -c $((${metaskip}-${tailskip})) \
1282 | tar -xzf -
1283 else
1284 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1285 | head -c $((${metaskip}-${tailskip})) \
1286 | gzip -dc \
1287 > ${datafile}
1288 fi
1289 else
1290 if [ ${istar} -eq 1 ] ; then
1291 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1292 | head -c $((${metaskip}-${tailskip})) \
1293 | tar --no-same-owner -xf -
1294 else
1295 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1296 | head -c $((${metaskip}-${tailskip})) \
1297 > ${datafile}
1298 fi
1299 fi
1300 true
1301 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1302 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1303}
1304
1305# @FUNCTION: unpack_makeself
1306# @USAGE: [file to unpack] [offset] [tail|dd]
1307# @DESCRIPTION:
1308# Unpack those pesky makeself generated files ...
1309# They're shell scripts with the binary package tagged onto
1310# the end of the archive. Loki utilized the format as does
1311# many other game companies.
1312#
1313# If the file is not specified, then ${A} is used. If the
1314# offset is not specified then we will attempt to extract
1315# the proper offset from the script itself.
1316unpack_makeself() {
1317 local src_input=${1:-${A}}
1318 local src=$(find_unpackable_file "${src_input}")
1319 local skip=$2
1320 local exe=$3
1321
1322 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1323
1324 local shrtsrc=$(basename "${src}")
1325 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1326 if [[ -z ${skip} ]] ; then
1327 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1328 local skip=0
1329 exe=tail
1330 case ${ver} in 966 case ${size} in
1331 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 967 16|22|24|32|36|48|64|72|96|128|192|256)
1332 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 968 size=${size}x${size};;
1333 ;; 969 scalable)
1334 2.0|2.0.1)
1335 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1336 ;;
1337 2.1.1)
1338 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1339 let skip="skip + 1"
1340 ;;
1341 2.1.2)
1342 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1343 let skip="skip + 1"
1344 ;;
1345 2.1.3)
1346 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1347 let skip="skip + 1"
1348 ;;
1349 2.1.4|2.1.5)
1350 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1351 skip=$(head -n ${skip} "${src}" | wc -c)
1352 exe="dd"
1353 ;; 970 ;;
1354 *) 971 *)
1355 eerror "I'm sorry, but I was unable to support the Makeself file." 972 eerror "${size} is an unsupported icon size!"
1356 eerror "The version I detected was '${ver}'." 973 exit 1;;
1357 eerror "Please file a bug about the file ${shrtsrc} at"
1358 eerror "http://bugs.gentoo.org/ so that support can be added."
1359 die "makeself version '${ver}' not supported"
1360 ;;
1361 esac 974 esac
1362 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 975 shift 2;;
1363 fi 976 -t|--theme)
1364 case ${exe} in 977 theme=${2}
1365 tail) exe="tail -n +${skip} '${src}'";; 978 shift 2;;
1366 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 979 -c|--context)
1367 *) die "makeself cant handle exe '${exe}'" 980 context=${2}
1368 esac 981 shift 2;;
1369
1370 # lets grab the first few bytes of the file to figure out what kind of archive it is
1371 local tmpfile=$(emktemp)
1372 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1373 local filetype=$(file -b "${tmpfile}")
1374 case ${filetype} in
1375 *tar\ archive*)
1376 eval ${exe} | tar --no-same-owner -xf -
1377 ;;
1378 bzip2*)
1379 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1380 ;;
1381 gzip*)
1382 eval ${exe} | tar --no-same-owner -xzf -
1383 ;;
1384 compress*)
1385 eval ${exe} | gunzip | tar --no-same-owner -xf -
1386 ;;
1387 *) 982 *)
1388 eerror "Unknown filetype \"${filetype}\" ?"
1389 false
1390 ;;
1391 esac
1392 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1393}
1394
1395# @FUNCTION: check_license
1396# @USAGE: [license]
1397# @DESCRIPTION:
1398# Display a license for user to accept. If no license is
1399# specified, then ${LICENSE} is used.
1400check_license() {
1401 local lic=$1
1402 if [ -z "${lic}" ] ; then
1403 lic="${PORTDIR}/licenses/${LICENSE}"
1404 else
1405 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1406 lic="${PORTDIR}/licenses/${lic}"
1407 elif [ -e "${PWD}/${lic}" ] ; then
1408 lic="${PWD}/${lic}"
1409 elif [ -e "${lic}" ] ; then
1410 lic="${lic}"
1411 fi
1412 fi
1413 local l="`basename ${lic}`"
1414
1415 # here is where we check for the licenses the user already
1416 # accepted ... if we don't find a match, we make the user accept
1417 local alic
1418 eshopts_push -o noglob # so that bash doesn't expand "*"
1419 for alic in ${ACCEPT_LICENSE} ; do
1420 if [[ ${alic} == ${l} ]]; then
1421 eshopts_pop
1422 return 0
1423 fi
1424 done
1425 eshopts_pop
1426 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1427
1428 local licmsg=$(emktemp)
1429 cat <<-EOF > ${licmsg}
1430 **********************************************************
1431 The following license outlines the terms of use of this
1432 package. You MUST accept this license for installation to
1433 continue. When you are done viewing, hit 'q'. If you
1434 CTRL+C out of this, the install will not run!
1435 **********************************************************
1436
1437 EOF
1438 cat ${lic} >> ${licmsg}
1439 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1440 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1441 read alic
1442 case ${alic} in
1443 yes|Yes|y|Y)
1444 return 0
1445 ;;
1446 *)
1447 echo;echo;echo
1448 eerror "You MUST accept the license to continue! Exiting!"
1449 die "Failed to accept license"
1450 ;;
1451 esac
1452}
1453
1454# @FUNCTION: cdrom_get_cds
1455# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1456# @DESCRIPTION:
1457# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1458# the whole 'non-interactive' policy, but damnit I want CD support !
1459#
1460# With these cdrom functions we handle all the user interaction and
1461# standardize everything. All you have to do is call cdrom_get_cds()
1462# and when the function returns, you can assume that the cd has been
1463# found at CDROM_ROOT.
1464#
1465# The function will attempt to locate a cd based upon a file that is on
1466# the cd. The more files you give this function, the more cds
1467# the cdrom functions will handle.
1468#
1469# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1470# etc... If you want to give the cds better names, then just export
1471# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1472# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1473# also use the CDROM_NAME_SET bash array.
1474#
1475# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1476cdrom_get_cds() {
1477 # first we figure out how many cds we're dealing with by
1478 # the # of files they gave us
1479 local cdcnt=0
1480 local f=
1481 for f in "$@" ; do
1482 ((++cdcnt))
1483 export CDROM_CHECK_${cdcnt}="$f"
1484 done
1485 export CDROM_TOTAL_CDS=${cdcnt}
1486 export CDROM_CURRENT_CD=1
1487
1488 # now we see if the user gave use CD_ROOT ...
1489 # if they did, let's just believe them that it's correct
1490 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1491 local var=
1492 cdcnt=0
1493 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1494 ((++cdcnt))
1495 var="CD_ROOT_${cdcnt}"
1496 [[ -z ${!var} ]] && var="CD_ROOT"
1497 if [[ -z ${!var} ]] ; then 983 if [[ -z ${size} ]] ; then
1498 eerror "You must either use just the CD_ROOT" 984 insinto /usr/share/pixmaps
1499 eerror "or specify ALL the CD_ROOT_X variables." 985 else
1500 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 986 insinto /usr/share/icons/${theme}/${size}/${context}
1501 die "could not locate CD_ROOT_${cdcnt}"
1502 fi 987 fi
1503 done
1504 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1505 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1506 export CDROM_SET=-1
1507 for f in ${CDROM_CHECK_1//:/ } ; do
1508 ((++CDROM_SET))
1509 [[ -e ${CD_ROOT}/${f} ]] && break
1510 done
1511 export CDROM_MATCH=${f}
1512 return
1513 fi
1514 988
1515 # User didn't help us out so lets make sure they know they can 989 if [[ ${funcname} == doicon ]] ; then
1516 # simplify the whole process ...
1517 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1518 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1519 echo
1520 einfo "If you do not have the CD, but have the data files"
1521 einfo "mounted somewhere on your filesystem, just export"
1522 einfo "the variable CD_ROOT so that it points to the"
1523 einfo "directory containing the files."
1524 echo
1525 einfo "For example:"
1526 einfo "export CD_ROOT=/mnt/cdrom"
1527 echo
1528 else
1529 if [[ -n ${CDROM_NAME_SET} ]] ; then
1530 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1531 cdcnt=0
1532 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1533 ((++cdcnt))
1534 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1535 done
1536 fi
1537
1538 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1539 cdcnt=0
1540 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1541 ((++cdcnt))
1542 var="CDROM_NAME_${cdcnt}"
1543 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1544 done
1545 echo
1546 einfo "If you do not have the CDs, but have the data files"
1547 einfo "mounted somewhere on your filesystem, just export"
1548 einfo "the following variables so they point to the right place:"
1549 einfon ""
1550 cdcnt=0
1551 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1552 ((++cdcnt))
1553 echo -n " CD_ROOT_${cdcnt}"
1554 done
1555 echo
1556 einfo "Or, if you have all the files in the same place, or"
1557 einfo "you only have one cdrom, you can export CD_ROOT"
1558 einfo "and that place will be used as the same data source"
1559 einfo "for all the CDs."
1560 echo
1561 einfo "For example:"
1562 einfo "export CD_ROOT_1=/mnt/cdrom"
1563 echo
1564 fi
1565
1566 export CDROM_SET=""
1567 export CDROM_CURRENT_CD=0
1568 cdrom_load_next_cd
1569}
1570
1571# @FUNCTION: cdrom_load_next_cd
1572# @DESCRIPTION:
1573# Some packages are so big they come on multiple CDs. When you're done reading
1574# files off a CD and want access to the next one, just call this function.
1575# Again, all the messy details of user interaction are taken care of for you.
1576# Once this returns, just read the variable CDROM_ROOT for the location of the
1577# mounted CD. Note that you can only go forward in the CD list, so make sure
1578# you only call this function when you're done using the current CD.
1579cdrom_load_next_cd() {
1580 local var
1581 ((++CDROM_CURRENT_CD))
1582
1583 unset CDROM_ROOT
1584 var=CD_ROOT_${CDROM_CURRENT_CD}
1585 [[ -z ${!var} ]] && var="CD_ROOT"
1586 if [[ -z ${!var} ]] ; then 990 if [[ -f $1 ]] ; then
1587 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 991 doins "${1}"
1588 _cdrom_locate_file_on_cd ${!var} 992 elif [[ -d $1 ]] ; then
1589 else 993 shopt -s nullglob
1590 export CDROM_ROOT=${!var} 994 doins "${1}"/*.{png,svg}
1591 fi 995 shopt -u nullglob
1592
1593 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1594}
1595
1596# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1597# functions. this should *never* be called from an ebuild.
1598# all it does is try to locate a give file on a cd ... if the cd isn't
1599# found, then a message asking for the user to insert the cdrom will be
1600# displayed and we'll hang out here until:
1601# (1) the file is found on a mounted cdrom
1602# (2) the user hits CTRL+C
1603_cdrom_locate_file_on_cd() {
1604 local mline=""
1605 local showedmsg=0 showjolietmsg=0
1606
1607 while [[ -z ${CDROM_ROOT} ]] ; do
1608 local i=0
1609 local -a cdset=(${*//:/ })
1610 if [[ -n ${CDROM_SET} ]] ; then
1611 cdset=(${cdset[${CDROM_SET}]})
1612 fi
1613
1614 while [[ -n ${cdset[${i}]} ]] ; do
1615 local dir=$(dirname ${cdset[${i}]})
1616 local file=$(basename ${cdset[${i}]})
1617
1618 local point= node= fs= foo=
1619 while read point node fs foo ; do
1620 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1621 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1622 && continue
1623 point=${point//\040/ }
1624 [[ ! -d ${point}/${dir} ]] && continue
1625 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1626 export CDROM_ROOT=${point}
1627 export CDROM_SET=${i}
1628 export CDROM_MATCH=${cdset[${i}]}
1629 return
1630 done <<< "$(get_mounts)"
1631
1632 ((++i))
1633 done
1634
1635 echo
1636 if [[ ${showedmsg} -eq 0 ]] ; then
1637 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1638 if [[ -z ${CDROM_NAME} ]] ; then
1639 einfo "Please insert+mount the cdrom for ${PN} now !"
1640 else 996 else
1641 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 997 eerror "${1} is not a valid file/directory!"
998 exit 1
1642 fi 999 fi
1643 else 1000 else
1644 if [[ -z ${CDROM_NAME_1} ]] ; then 1001 break
1645 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1646 else
1647 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1648 einfo "Please insert+mount the ${!var} cdrom now !"
1649 fi
1650 fi 1002 fi
1651 showedmsg=1 1003 shift 1;;
1652 fi 1004 esac
1653 einfo "Press return to scan for the cd again"
1654 einfo "or hit CTRL+C to abort the emerge."
1655 echo
1656 if [[ ${showjolietmsg} -eq 0 ]] ; then
1657 showjolietmsg=1
1658 else
1659 ewarn "If you are having trouble with the detection"
1660 ewarn "of your CD, it is possible that you do not have"
1661 ewarn "Joliet support enabled in your kernel. Please"
1662 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1663 ebeep 5
1664 fi
1665 read || die "something is screwed with your system"
1666 done 1005 done
1006 if [[ ${funcname} == newicon ]] ; then
1007 newins "$@"
1008 fi
1009 ) || die
1010}
1011
1012# @FUNCTION: doicon
1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
1018#
1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
1030#
1031# icons: list of icons
1032#
1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
1034# results in: insinto /usr/share/pixmaps
1035# doins foobar.png fuqbar.svg suckbar.png
1036#
1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
1039# doins foobar.png fuqbar.png blobbar.png
1040# @CODE
1041doicon() {
1042 _iconins ${FUNCNAME} "$@"
1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
1049#
1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
1052# results in: insinto /usr/share/pixmaps
1053# newins foobar.png NEWNAME.png
1054#
1055# example 2: newicon -s 48 foobar.png NEWNAME.png
1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
1057# newins foobar.png NEWNAME.png
1058# @CODE
1059newicon() {
1060 _iconins ${FUNCNAME} "$@"
1667} 1061}
1668 1062
1669# @FUNCTION: strip-linguas 1063# @FUNCTION: strip-linguas
1670# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>] 1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1671# @DESCRIPTION: 1065# @DESCRIPTION:
1688 else 1082 else
1689 newls="" 1083 newls=""
1690 fi 1084 fi
1691 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1692 if [[ ${op} == "-i" ]] ; then 1086 if [[ ${op} == "-i" ]] ; then
1693 hasq ${f} ${ls} && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1694 else 1088 else
1695 hasq ${f} ${ls} || newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1696 fi 1090 fi
1697 done 1091 done
1698 ls=${newls} 1092 ls=${newls}
1699 done 1093 done
1700 else 1094 else
1702 fi 1096 fi
1703 1097
1704 nols="" 1098 nols=""
1705 newls="" 1099 newls=""
1706 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1707 if hasq ${f} ${ls} ; then 1101 if has ${f} ${ls} ; then
1708 newls="${newls} ${f}" 1102 newls="${newls} ${f}"
1709 else 1103 else
1710 nols="${nols} ${f}" 1104 nols="${nols} ${f}"
1711 fi 1105 fi
1712 done 1106 done
1713 [[ -n ${nols} ]] \ 1107 [[ -n ${nols} ]] \
1714 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols} 1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1715 export LINGUAS=${newls:1} 1109 export LINGUAS=${newls:1}
1716} 1110}
1717 1111
1718# @FUNCTION: preserve_old_lib 1112# @FUNCTION: preserve_old_lib
1719# @USAGE: <libs to preserve> [more libs] 1113# @USAGE: <libs to preserve> [more libs]
1767 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1768 ewarn "in order to remove these old dependencies. If you do not have this" 1162 ewarn "in order to remove these old dependencies. If you do not have this"
1769 ewarn "helper program, simply emerge the 'gentoolkit' package." 1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1770 ewarn 1164 ewarn
1771 fi 1165 fi
1772 ewarn " # revdep-rebuild --library ${lib##*/}" 1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1773 done 1167 done
1774 if [[ ${notice} -eq 1 ]] ; then
1775 ewarn
1776 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1777 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1778 for lib in "$@" ; do
1779 ewarn " # rm '${lib}'"
1780 done
1781 fi
1782} 1168}
1783 1169
1784# @FUNCTION: built_with_use 1170# @FUNCTION: built_with_use
1785# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1786# @DESCRIPTION: 1172# @DESCRIPTION:
1923 else 1309 else
1924 newbin "${tmpwrapper}" "${wrapper}" || die 1310 newbin "${tmpwrapper}" "${wrapper}" || die
1925 fi 1311 fi
1926} 1312}
1927 1313
1928# @FUNCTION: prepalldocs 1314# @FUNCTION: path_exists
1929# @USAGE: 1315# @USAGE: [-a|-o] <paths>
1930# @DESCRIPTION: 1316# @DESCRIPTION:
1931# Compress files in /usr/share/doc which are not already 1317# Check if the specified paths exist. Works for all types of paths
1932# compressed, excluding /usr/share/doc/${PF}/html. 1318# (files/dirs/etc...). The -a and -o flags control the requirements
1933# Uses the ecompressdir to do the compression. 1319# of the paths. They correspond to "and" and "or" logic. So the -a
1934# 2009-02-18 by betelgeuse: 1320# flag means all the paths must exist while the -o flag means at least
1935# Commented because ecompressdir is even more internal to 1321# one of the paths must exist. The default behavior is "and". If no
1936# Portage than prepalldocs (it's not even mentioned in man 5 1322# paths are specified, then the return value is "false".
1937# ebuild). Please submit a better version for review to gentoo-dev 1323path_exists() {
1938# if you want prepalldocs here. 1324 local opt=$1
1939#prepalldocs() { 1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1940# if [[ -n $1 ]] ; then 1326
1941# ewarn "prepalldocs: invalid usage; takes no arguments" 1327 # no paths -> return false
1328 # same behavior as: [[ -e "" ]]
1329 [[ $# -eq 0 ]] && return 1
1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--all' argument is passed, all .la files are removed. This is
1393# usually useful when the package installs plugins and does not use .la
1394# files for loading them.
1395#
1396# The .a files are only removed whenever corresponding .la files state
1397# that they should not be linked to, i.e. whenever these files
1398# correspond to plugins.
1399#
1400# Note: if your package installs both static libraries and .pc files,
1401# you need to add pkg-config to your DEPEND.
1402prune_libtool_files() {
1403 debug-print-function ${FUNCNAME} "$@"
1404
1405 local removing_all opt
1406 for opt; do
1407 case "${opt}" in
1408 --all)
1409 removing_all=1
1410 ;;
1411 *)
1412 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1413 esac
1414 done
1415
1416 local f
1417 local queue=()
1418 while IFS= read -r -d '' f; do # for all .la files
1419 local archivefile=${f/%.la/.a}
1420
1421 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1422
1423 # Remove static libs we're not supposed to link against.
1424 if grep -q '^shouldnotlink=yes$' "${f}"; then
1425 if [[ -f ${archivefile} ]]; then
1426 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1427 queue+=( "${archivefile}" )
1428 fi
1429
1430 # The .la file may be used by a module loader, so avoid removing it
1431 # unless explicitly requested.
1432 [[ ${removing_all} ]] || continue
1433 fi
1434
1435 # Remove .la files when:
1436 # - user explicitly wants us to remove all .la files,
1437 # - respective static archive doesn't exist,
1438 # - they are covered by a .pc file already,
1439 # - they don't provide any new information (no libs & no flags).
1440 local reason pkgconfig_scanned
1441 if [[ ${removing_all} ]]; then
1442 reason='requested'
1443 elif [[ ! -f ${archivefile} ]]; then
1444 reason='no static archive'
1445 elif [[ ! $(sed -nre \
1446 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1447 "${f}") ]]; then
1448 reason='no libs & flags'
1449 else
1450 if [[ ! ${pkgconfig_scanned} ]]; then
1451 # Create a list of all .pc-covered libs.
1452 local pc_libs=()
1453 if [[ ! ${removing_all} ]]; then
1454 local f
1455 local tf=${T}/prune-lt-files.pc
1456 local pkgconf=$(tc-getPKG_CONFIG)
1457
1458 while IFS= read -r -d '' f; do # for all .pc files
1459 local arg
1460
1461 sed -e '/^Requires:/d' "${f}" > "${tf}"
1462 for arg in $("${pkgconf}" --libs "${tf}"); do
1463 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1464 done
1465 done < <(find "${D}" -type f -name '*.pc' -print0)
1466
1467 rm -f "${tf}"
1468 fi
1469
1470 pkgconfig_scanned=1
1471 fi
1472
1473 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1474 fi
1475
1476 if [[ ${reason} ]]; then
1477 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1478 queue+=( "${f}" )
1479 fi
1480 done < <(find "${D}" -xtype f -name '*.la' -print0)
1481
1482 if [[ ${queue[@]} ]]; then
1483 rm -f "${queue[@]}"
1942# fi 1484 fi
1485}
1943 1486
1944# cd "${D}" 1487check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1945# [[ -d usr/share/doc ]] || return 0
1946 1488
1947# find usr/share/doc -exec gzip {} + 1489fi
1948# ecompressdir --ignore /usr/share/doc/${PF}/html
1949# ecompressdir --queue /usr/share/doc
1950#}

Legend:
Removed from v.1.337  
changed lines
  Added in v.1.407

  ViewVC Help
Powered by ViewVC 1.1.20